# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['TableColumnMaskingPolicyApplicationArgs', 'TableColumnMaskingPolicyApplication']

@pulumi.input_type
class TableColumnMaskingPolicyApplicationArgs:
    def __init__(__self__, *,
                 column: pulumi.Input[builtins.str],
                 masking_policy: pulumi.Input[builtins.str],
                 table: pulumi.Input[builtins.str]):
        """
        The set of arguments for constructing a TableColumnMaskingPolicyApplication resource.
        :param pulumi.Input[builtins.str] column: The column to apply the masking policy to.
        :param pulumi.Input[builtins.str] masking_policy: Fully qualified name (`database.schema.policyname`) of the policy to apply.
        :param pulumi.Input[builtins.str] table: The fully qualified name (`database.schema.table`) of the table to apply the masking policy to.
        """
        pulumi.set(__self__, "column", column)
        pulumi.set(__self__, "masking_policy", masking_policy)
        pulumi.set(__self__, "table", table)

    @property
    @pulumi.getter
    def column(self) -> pulumi.Input[builtins.str]:
        """
        The column to apply the masking policy to.
        """
        return pulumi.get(self, "column")

    @column.setter
    def column(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "column", value)

    @property
    @pulumi.getter(name="maskingPolicy")
    def masking_policy(self) -> pulumi.Input[builtins.str]:
        """
        Fully qualified name (`database.schema.policyname`) of the policy to apply.
        """
        return pulumi.get(self, "masking_policy")

    @masking_policy.setter
    def masking_policy(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "masking_policy", value)

    @property
    @pulumi.getter
    def table(self) -> pulumi.Input[builtins.str]:
        """
        The fully qualified name (`database.schema.table`) of the table to apply the masking policy to.
        """
        return pulumi.get(self, "table")

    @table.setter
    def table(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "table", value)


@pulumi.input_type
class _TableColumnMaskingPolicyApplicationState:
    def __init__(__self__, *,
                 column: Optional[pulumi.Input[builtins.str]] = None,
                 masking_policy: Optional[pulumi.Input[builtins.str]] = None,
                 table: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering TableColumnMaskingPolicyApplication resources.
        :param pulumi.Input[builtins.str] column: The column to apply the masking policy to.
        :param pulumi.Input[builtins.str] masking_policy: Fully qualified name (`database.schema.policyname`) of the policy to apply.
        :param pulumi.Input[builtins.str] table: The fully qualified name (`database.schema.table`) of the table to apply the masking policy to.
        """
        if column is not None:
            pulumi.set(__self__, "column", column)
        if masking_policy is not None:
            pulumi.set(__self__, "masking_policy", masking_policy)
        if table is not None:
            pulumi.set(__self__, "table", table)

    @property
    @pulumi.getter
    def column(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The column to apply the masking policy to.
        """
        return pulumi.get(self, "column")

    @column.setter
    def column(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "column", value)

    @property
    @pulumi.getter(name="maskingPolicy")
    def masking_policy(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Fully qualified name (`database.schema.policyname`) of the policy to apply.
        """
        return pulumi.get(self, "masking_policy")

    @masking_policy.setter
    def masking_policy(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "masking_policy", value)

    @property
    @pulumi.getter
    def table(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The fully qualified name (`database.schema.table`) of the table to apply the masking policy to.
        """
        return pulumi.get(self, "table")

    @table.setter
    def table(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "table", value)


@pulumi.type_token("snowflake:index/tableColumnMaskingPolicyApplication:TableColumnMaskingPolicyApplication")
class TableColumnMaskingPolicyApplication(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 column: Optional[pulumi.Input[builtins.str]] = None,
                 masking_policy: Optional[pulumi.Input[builtins.str]] = None,
                 table: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Create a TableColumnMaskingPolicyApplication resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] column: The column to apply the masking policy to.
        :param pulumi.Input[builtins.str] masking_policy: Fully qualified name (`database.schema.policyname`) of the policy to apply.
        :param pulumi.Input[builtins.str] table: The fully qualified name (`database.schema.table`) of the table to apply the masking policy to.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: TableColumnMaskingPolicyApplicationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a TableColumnMaskingPolicyApplication resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param TableColumnMaskingPolicyApplicationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(TableColumnMaskingPolicyApplicationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 column: Optional[pulumi.Input[builtins.str]] = None,
                 masking_policy: Optional[pulumi.Input[builtins.str]] = None,
                 table: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = TableColumnMaskingPolicyApplicationArgs.__new__(TableColumnMaskingPolicyApplicationArgs)

            if column is None and not opts.urn:
                raise TypeError("Missing required property 'column'")
            __props__.__dict__["column"] = column
            if masking_policy is None and not opts.urn:
                raise TypeError("Missing required property 'masking_policy'")
            __props__.__dict__["masking_policy"] = masking_policy
            if table is None and not opts.urn:
                raise TypeError("Missing required property 'table'")
            __props__.__dict__["table"] = table
        super(TableColumnMaskingPolicyApplication, __self__).__init__(
            'snowflake:index/tableColumnMaskingPolicyApplication:TableColumnMaskingPolicyApplication',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            column: Optional[pulumi.Input[builtins.str]] = None,
            masking_policy: Optional[pulumi.Input[builtins.str]] = None,
            table: Optional[pulumi.Input[builtins.str]] = None) -> 'TableColumnMaskingPolicyApplication':
        """
        Get an existing TableColumnMaskingPolicyApplication resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] column: The column to apply the masking policy to.
        :param pulumi.Input[builtins.str] masking_policy: Fully qualified name (`database.schema.policyname`) of the policy to apply.
        :param pulumi.Input[builtins.str] table: The fully qualified name (`database.schema.table`) of the table to apply the masking policy to.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _TableColumnMaskingPolicyApplicationState.__new__(_TableColumnMaskingPolicyApplicationState)

        __props__.__dict__["column"] = column
        __props__.__dict__["masking_policy"] = masking_policy
        __props__.__dict__["table"] = table
        return TableColumnMaskingPolicyApplication(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def column(self) -> pulumi.Output[builtins.str]:
        """
        The column to apply the masking policy to.
        """
        return pulumi.get(self, "column")

    @property
    @pulumi.getter(name="maskingPolicy")
    def masking_policy(self) -> pulumi.Output[builtins.str]:
        """
        Fully qualified name (`database.schema.policyname`) of the policy to apply.
        """
        return pulumi.get(self, "masking_policy")

    @property
    @pulumi.getter
    def table(self) -> pulumi.Output[builtins.str]:
        """
        The fully qualified name (`database.schema.table`) of the table to apply the masking policy to.
        """
        return pulumi.get(self, "table")

